﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;

namespace HierarchicalGridHideRows
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {

                Session["DS"] = GetData();
                Session["Sizes"] = GetSizes();

            }
            this.WebHierarchicalDataGrid1.DataSource = (DataSet)Session["DS"];
            this.WebHierarchicalDataGrid1_DropDownProvider1.EditorControl.DataSource = (List<string>)Session["Sizes"];
           
        }

        public  List<string> GetSizes() 
        {
            List<string> sizes = new List<string>();

            sizes.Add("Small");
            sizes.Add("Medium");
            sizes.Add("Large");

            return sizes;
        }

        public DataSet GetData()
        {
            DataSet ds = new DataSet();

            string[] names = { "Peter", "Maria", "John", "Vladimir", "Gustavo" };

            DataTable ct = new DataTable("CustomersTable");
            var keys = new DataColumn[1];

            ct.Columns.Add("CustomerID", typeof(int));
            ct.Columns.Add("Name", typeof(string));
            ct.Columns.Add("Date", typeof(DateTime));
           

            for (int i = 0; i < 10; i++)
            {
                var row = ct.Rows.Add();
                row[0] = i + 1;
                row[1] = names[i % 5];
                row[2] = DateTime.Now.AddDays(i * 2);                
            }
            keys[0] = ct.Columns["CustomerID"];

            ct.PrimaryKey = keys;

            DataTable ordersTable = new DataTable("OrdersTable");
            var orderKeys = new DataColumn[2];

            ordersTable.Columns.Add("CustomerID", typeof(int));
            ordersTable.Columns.Add("OrderID", typeof(int));
            ordersTable.Columns.Add("Date", typeof(DateTime));
            ordersTable.Columns.Add("Size", typeof(string));


            foreach (DataRow customerRow in ct.Rows)
            {
                DataRow row = ordersTable.NewRow();

                for (int i = 0; i < 4; i++)
                {

                    row = ordersTable.NewRow();

                    row["CustomerId"] = customerRow["CustomerId"];
                    row["OrderID"] = i + 10 * Convert.ToInt32(customerRow["Customerid"]);
                    DateTime date = (DateTime)customerRow["Date"];
                    row["Date"] = date.AddDays(i * 3);
                    if (i % 3 == 0) row["Size"] = "Small";
                    else if (i % 3 == 1) row["Size"] = "Medium";
                    else row["Size"] = "Large";
                    ordersTable.Rows.Add(row);
                }
            }

            keys[0] = ordersTable.Columns["OrderID"];
            ordersTable.PrimaryKey = keys;

            ds.Tables.Add(ct);
            ds.Tables.Add(ordersTable);
            DataRelation relCustOrder = new DataRelation("CustOrder",
                ds.Tables["CustomersTable"].Columns["CustomerId"],
                ds.Tables["OrdersTable"].Columns["CustomerId"]);
            ds.Relations.Add(relCustOrder);

            return ds;

        }
    }
}